# vim:set ts=2 sw=2 sts=2 et:
from rzn.api import obj

def updatelib(libname):
  """ update all parts from library libname to the latest version """
  libs = ui.libraryManager()
  uname, lname = libname.split("/")
  librev = libs.library(lname, uname).rev()
  proj = ui.currentTab().project()
  proj.setDependencyRev(libname, librev)
  updated = 0
  for p in proj.schematic.objs(objtype=obj.SubPart):
    if p.lib == libname:
      p.reloadPart()
      if p.other():
        p.other().reloadPart()
      updated += 1
  return "updated %d parts" % updated

def updatelibs():
  """ update all parts from  all libraries to the latest versions """
  proj = ui.currentTab().project()
  for libname,_ in proj.dependencies():
    updatelib(libname)
